diff --git a/encoder/analyse.c b/encoder/analyse.c
index ac6e4ad..df8603f 100644
--- a/encoder/analyse.c
+++ b/encoder/analyse.c
@@ -821,7 +821,7 @@ static void x264_intra_rd_refine( x264_t *h, x264_mb_analysis_t *a )
                     pels[1] = *(uint32_t*)(p_dst_by+1*FDEC_STRIDE);
                     pels[2] = *(uint32_t*)(p_dst_by+2*FDEC_STRIDE);
                     pels[3] = *(uint32_t*)(p_dst_by+3*FDEC_STRIDE);
-                    i_nnz = h->mb.cache.non_zero_count[x264_scan8[idx]];
+                    i_nnz = array_non_zero_count( h->dct.block[idx].residual_ac, 15 );
                 }
             }
 
@@ -875,7 +875,7 @@ static void x264_intra_rd_refine( x264_t *h, x264_mb_analysis_t *a )
                         for( j=0; j<7; j++ )
                             pels_v[j] = p_dst_by[7+j*FDEC_STRIDE];
                     for( j=0; j<3; j++ )
-                        i_nnz[j] = h->mb.cache.non_zero_count[x264_scan8[4*idx+j+1]];
+                        i_nnz[j] = array_non_zero( h->dct.luma8x8[4*idx+j+1] );
                 }
             }
 